NoteCell = {}
NoteCell.__index = NoteCell

function NoteCell:new(posArg, columnArg)

  local self = {}
  setmetatable(self, NoteCell)

  self.pattern = posArg.pattern
  self.track = posArg.track
  self.line = posArg.line
  self.column = posArg.column

  self.note = columnArg.note_value
  self.instrument = columnArg.instrument_value
  self.volume = columnArg.volume_value
  self.panning = columnArg.panning_value
  self.delay = columnArg.delay_value
  self.effectNumber = columnArg.effect_number_value
  self.effectAmount = columnArg.effect_amount_value
        
  return self
end

local function getLineNumber(numberOfSteps)
  return math.floor(numberOfSteps/256)
end

local function getDelayValue(numberOfSteps)
  return numberOfSteps % 256
end

function NoteCell:setNotePosition(numberOfSteps)

  local selectionInPattern = renoise.song().selection_in_pattern
  local startLine = selectionInPattern.start_line
  
  local lineNumber = getLineNumber(numberOfSteps)  
  self.line = startLine+lineNumber
  
  local delayValue = getDelayValue(numberOfSteps)
  self.delay = delayValue
end

