require 'NoteCell'

noteCells = {}

function getNoteColumn(pattern, track, line, column)
  
  return renoise.song():pattern(pattern)
                       :track(track)
                       :line(line)
                       :note_column(column) 
end

function setNoteColumn(noteColumn, noteCell)
  
  noteColumn.note_value = noteCell.note
  noteColumn.instrument_value = noteCell.instrument
  noteColumn.volume_value = noteCell.volume
  noteColumn.panning_value = noteCell.panning
  noteColumn.delay_value = noteCell.delay
  noteColumn.effect_number_value = noteCell.effectNumber
  noteColumn.effect_amount_value = noteCell.effectAmount
end

function collectNoteCellsFromSelection()
  
  local patternIndex = renoise.song().selected_pattern_index
  local visibleOnly = true
  for pos, column in renoise.song().pattern_iterator:note_columns_in_pattern(patternIndex, visibleOnly) do
  
    local trackIsNotMuted = renoise.song():track(pos.track).mute_state ~= renoise.Track.MUTE_STATE_OFF
    local columnIsNotMuted = (not renoise.song():track(pos.track):column_is_muted(pos.column))
    
    if column.is_selected and (not column.is_empty) and columnIsNotMuted and trackIsNotMuted then
      
      if noteCells[pos.track] == nil then
        noteCells[pos.track] = {}
      end
      
      table.insert(noteCells[pos.track], NoteCell:new(pos, column))
      column:clear()
    end    
  end
end

function pasteNoteCells()

  for trackIndex in pairs(noteCells) do
  
    for i = 1, #noteCells[trackIndex] do
  
      local noteCell = noteCells[trackIndex][i]
      local noteColumn = getNoteColumn(noteCell.pattern, noteCell.track, noteCell.line, noteCell.column)
      setNoteColumn(noteColumn, noteCell)
    end
  end

  noteCells = {}
end
